> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a KYC Document

> Create a container for files to be submitted

<Warning>
  **Caution – Legacy endpoints being superseded by the hosted KYC/KYB solution**

  Mangopay's [hosted KYC/KYB solution](/guides/users/verification/hosted) is becoming mandatory for all platforms (relying on the [IDV Session](/api-reference/idv-sessions/idv-session-object) object). The legacy KYC Document endpoints remain available for the sole purposes of [sending additional documents](/guides/users/verification/hosted/integration#sending-additional-documents), but this use case will also be handled by the hosted solution in future.
</Warning>

In Sandbox, you can set the KYC Document `Tag` to `accept` to simulate acceptance of the document after submission. Other values are available to simulate different refusal reasons – [see the guide for details](/guides/users/verification/documents/submission/how-to).

### Path parameters

<ParamField path="UserId" type="string" required>
  The unique identifier of the user.
</ParamField>

### Body parameters

<ParamField body="Type" type="string" required>
  **Allowed values:** `IDENTITY_PROOF`, `REGISTRATION_PROOF`, `ARTICLES_OF_ASSOCIATION`, `SHAREHOLDER_DECLARATION`, `ADDRESS_PROOF`

  The type of the document for the user verification.
</ParamField>

<ParamField body="Tag" type="string">
  Max. length: 255 characters

  Custom data that you can add to this object.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200">
    <ResponseField name="Type" type="string">
      **Returned values:** `IDENTITY_PROOF`, `REGISTRATION_PROOF`, `ARTICLES_OF_ASSOCIATION`, `SHAREHOLDER_DECLARATION`, `ADDRESS_PROOF`

      The type of the document for the user verification.
    </ResponseField>

    <ResponseField name="UserId" type="string">
      The unique identifier of the user.
    </ResponseField>

    <ResponseField name="Flags" type="array">
      **Returned values:** A code from the <a href="/guides/users/verification/documents/submission/refusals" target="_blank">Flags list</a>.

      The series of codes providing more precision regarding the reason why the identity proof document was refused. You can review the explanations for each code in the <a href="/guides/users/verification/documents/submission/refusals" target="_blank">Flags list</a>.
    </ResponseField>

    <ResponseField name="Id" type="string">
      The unique identifier of the KYC Document.
    </ResponseField>

    <ResponseField name="Tag" type="string">
      Max. length: 255 characters

      Custom data that you can add to this object.
    </ResponseField>

    <ResponseField name="CreationDate" type="Unix timestamp">
      The date and time at which the object was created.
    </ResponseField>

    <ResponseField name="ProcessedDate" type="Unix timestamp">
      The date and time at which the document was processed by Mangopay’s team.
    </ResponseField>

    <ResponseField name="Status" type="string">
      **Returned values:** `CREATED`, `VALIDATION_ASKED`, `VALIDATED`, `REFUSED`, `OUT_OF_DATE`

      The status of the document:

      * `CREATED` – The document container is created and files can be uploaded using the [POST Create a KYC Document Page](/api-reference/kyc-documents/create-kyc-document-page) endpoint before submission.
      * `VALIDATION_ASKED` – The document is submitted to Mangopay for validation.
      * `VALIDATED` – The document is validated by Mangopay’s teams.
      * `REFUSED` – The document is rejected by Mangopay’s teams and a new KYC Document object needs to be created to resubmit it. You can learn more about the reason why it was refused in the `RefusedReasonType` parameter.
      * `OUT_OF_DATE` – The document is downgraded and a new KYC Document object needs to be created to resubmit it.
    </ResponseField>

    <ResponseField name="RefusedReasonType" type="string">
      **Returned values:** DOCUMENT\_DO\_NOT\_MATCH\_USER\_DATA, DOCUMENT\_FALSIFIED, DOCUMENT\_HAS\_EXPIRED, DOCUMENT\_INCOMPLETE, DOCUMENT\_MISSING, DOCUMENT\_NOT\_ACCEPTED, DOCUMENT\_UNREADABLE, SPECIFIC\_CASE, UNDERAGE\_PERSON

      Returned `null` unless `Status` is `REFUSED`.

      The reason for the document refusal. See the <a href="/guides/users/verification/documents/submission/refusals">refused reason types</a> for more information depending on the document type.
    </ResponseField>

    <ResponseField name="RefusedReasonMessage" type="string">
      Max. length: 255 characters

      **Default value:** null

      Additional information about why the KYC Document was refused, provided by Mangopay’s team.
    </ResponseField>
  </Accordion>
</AccordionGroup>

<AccordionGroup>
  <Accordion title="400 - Natural user only allows IDENTITY_PROOF and ADDRESS_PROOF">
    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "da212cf3-7afb-4a49-9c6d-8fa2753f243c#1727446970",
        "Date": 1727446971,
        "errors": {
            "Type": "REGISTRATION_PROOF cannot be submitted for NATURAL_PERSON user"
        }
    }
    ```

    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "3824ad65-c0da-4da6-824c-697a58a77b2e#1727446982",
        "Date": 1727446983,
        "errors": {
            "Type": "ARTICLES_OF_ASSOCIATION cannot be submitted for NATURAL_PERSON user"
        }
    }
    ```

    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "d91835a1-ce46-4e55-866d-6f1e0de61e75#1727448032",
        "Date": 1727448034,
        "errors": {
            "Type": "SHAREHOLDER_DECLARATION cannot be submitted for NATURAL_PERSON user"
        }
    }
    ```
  </Accordion>

  <Accordion title="400 - Legal users don't allow ADDRESS_PROOF">
    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "43cddfad-fad7-4ed5-a9c6-bcc4d4b0ef42#1727447421",
        "Date": 1727447422,
        "errors": {
            "Type": "ADDRESS_PROOF cannot be submitted for BUSINESS user"
        }
    }
    ```

    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "573e126e-800a-42c4-89cd-b78ff10f0327#1727447489",
        "Date": 1727447490,
        "errors": {
            "Type": "ADDRESS_PROOF cannot be submitted for PARTNERSHIP user"
        }
    }
    ```

    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "2fb6cf62-cfb4-4a62-9401-763a53d7f602#1727447342",
        "Date": 1727447343,
        "errors": {
            "Type": "ADDRESS_PROOF cannot be submitted for ORGANIZATION user"
        }
    }
    ```

    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "444f5241-5263-4cc0-9ad2-26c871a6cf44#1727447141",
        "Date": 1727447142,
        "errors": {
            "Type": "ADDRESS_PROOF cannot be submitted for SOLETRADER user"
        }
    }
    ```
  </Accordion>

  <Accordion title="400 - Soletrader doesn't allow ARTICLES_OF_ASSOCIATION">
    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "fa1adc02-dc72-47be-ab3c-4a0a4ce4ef6b#1727447083",
        "Date": 1727447084,
        "errors": {
            "Type": "ARTICLES_OF_ASSOCIATION cannot be submitted for SOLETRADER user"
        }
    }
    ```
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200  theme={null}
  {
      "Type": "IDENTITY_PROOF",
      "UserId": "user_m_01J8J0Y9DPNYRA9RB532CCND9Q",
      "Flags": [],
      "Id": "kyc_01JA5M2N33ENJHWVPQXVJ6Q51P",
      "Tag": "Created using Mangopay API Postman Collection",
      "CreationDate": 1728913167,
      "ProcessedDate": null,
      "Status": "CREATED",
      "RefusedReasonType": null,
      "RefusedReasonMessage": null
  }  
  ```
</ResponseExample>

<RequestExample>
  ```json REST   theme={null}
  {
      "Tag": "accept",
      "Type": "IDENTITY_PROOF"
  }  
  ```

  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  try {

      $userId = '198675238';
      
      $kycDocument = new \MangoPay\KycDocument();

      $kycDocument->Type = \MangoPay\KycDocumentType::IdentityProof;
      $kycDocument->Tag = 'accept';

      $response = $api->Users->CreateKycDocument($userId, $kycDocument);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk');
  const mangopay = new mangopayInstance({
      clientId: "your-client-id",
      clientApiKey: "your-api-key",
  });

  let myUser = {
      Id: 'user_m_01KMD8QZHCVY2VPYV020RDBZGA'
  }

  let myKycDocument = {
      Type: 'IDENTITY_PROOF',
      Tag: "accept"
  }

  const createKycDocument = async (userId, kycDocument) => {
      return await mangopay.Users.createKycDocument(userId, kycDocument)
          .then((response) => {
              console.info(response)
              return response
          }).catch((err) => {
              console.log(err);
              return false
          }); 
  }

  createKycDocument(myUser.Id, myKycDocument)
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def createKycDocument(userId, kycDocumentObject)
      begin
          response = MangoPay::KycDocument.create(userId, kycDocumentObject)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to create KYC Document: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myUser = {
      Id: '194150513'
  }

  myKycDocument = {
      Type: 'IDENTITY_PROOF',
      Tag: 'accept'
  }

  createKycDocument(myUser[:Id], myKycDocument)  
  ```

  ```java Java   theme={null}
  import com.mangopay.MangoPayApi;
  import com.mangopay.core.Address;
  import com.mangopay.core.enumerations.KycDocumentType;
  import com.mangopay.entities.KycDocument;

  import java.lang.reflect.Field;

  public class CreateKYCDoc {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          var userId = "user_m_01HR9SZTXDRY1PCFHSJFAPC0YJ";

          KycDocument createKycDoc = mangopay.getUserApi().createKycDocument(
              userId, 
              KycDocumentType.IDENTITY_PROOF, 
              "accept"
          );

          System.out.println(String.format("id: %s", createKycDoc.getId()));
          printObjectFields(createKycDoc);
      }

      private static void printObjectFields(Object obj) {
          Class<?> objClass = obj.getClass();
          Field[] fields = objClass.getDeclaredFields();
          for (Field field : fields) {
              field.setAccessible(true);
              try {
                  Object value = field.get(obj);
                  if (value instanceof Address) {
                      System.out.println(field.getName() + ": ");
                      printObjectFields(value); 
                  } else {
                      System.out.println(field.getName() + ": " + value);
                  }
              } catch (IllegalAccessException e) {
                  e.printStackTrace();
              }
          }
      }
  }  
  ```

  ```python Python   theme={null}
  from pprint import pprint
  import mangopay

  mangopay.client_id = 'your-client-id'
  mangopay.apikey = 'your-api-key'

  from mangopay.api import APIRequest

  handler = APIRequest(sandbox=True)
  from mangopay.resources import Document, LegalUser

  legal_user = LegalUser(
      id = '210760575'
  )

  kyc_document = Document(type='REGISTRATION_PROOF', user=legal_user)
  create_kyc_document = kyc_document.save()

  pprint(create_kyc_document)  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using MangoPay.SDK.Core.Enumerations;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

          var userId = "user_m_01J2TZ261WZNDM0ZDRWGDYA4GN";
          var tag = "accept";

          var createKycDoc = await api.Users.CreateKycDocumentAsync(userId, KycDocumentType.IDENTITY_PROOF, tag);

          string prettyPrint = JsonConvert.SerializeObject(createKycDoc, Formatting.Indented);
          Console.WriteLine(prettyPrint);
      }
  }
  ```
</RequestExample>
